/********************************* (C) РОТЕК ***********************************
 * @module  bt_6701_settings
 * @file    bt_6701_settings.c
 * @version 1.0.0
 * @date    XX.XX.XXXX
 * $brief   bt_6701_settings
 *******************************************************************************
 * @history     Version  Author         Comment
 * XX.XX.XXXX   1.0.0    Telenkov D.A.  First release.
 *******************************************************************************
 */

#include "stm32f4xx.h"  
#include "common_config.h"
#include "bt_6701_settings.h"
#include "settings_api.h"
#include "common_config.h"

#include "FreeRTOS.h"
#include "task.h"

#include <string.h>
#include <stdlib.h>


/**
  * @brief  Общая структура настроек
  */
extern SETTINGS_t sSettings;

char * SETTINGS_GetTestState(void)
{
    return sSettings.sFlags.testState;
}

/**
  * @brief  Устанавливает Serno, но не сохраняет новые настройки во флеш
  */
void SETTINGS_SetSerno(char *serno)
{
    strcpy(sSettings.sInfo.serialNumber, serno);
}

/**
  * @brief  Устанавливает mac, но не сохраняет новые настройки во флеш
  */
void SETTINGS_SetMac(char *mac)
{
    strcpy(sSettings.sInfo.mac, mac);
}






/********************************* (C) РОТЕК **********************************/    
